function varargout = riesgo(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @riesgo_OpeningFcn, ...
                   'gui_OutputFcn',  @riesgo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
function riesgo_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
handles.DB.imgs{1}=imread('1.Liderazgo Rel_Soc_Trabj.png');
handles.DB.imgs{2}=imread('2.Control.png');
handles.DB.imgs{3}=imread('3.Demandas del trabajo.png');
handles.DB.imgs{4}=imread('4.Recompensas.png');
imshow('fondo.png')
set(handles.uitable1,'Data',nan(1,20),'ColumnEditable',true(1,20))

RandStream.setGlobalStream(RandStream('mt19937ar','Seed',387));
%si se quiere obtener nuevos resultados diferentes comentar la lnea 3
blancoynegro=false;%si se coloca true las grficas salen en blanco y negro
if ~exist('basededatos.mat','file')%si no existe la base de datos en Matlab entonces se crea
[datos,datosnum]=xlsread('Datos Experimentales NA2.xlsx');%se lee el archivo de Excel
save('basededatos','datos','datosnum');%se guarda la base de datos de Excel en Matlab
else%si ya existe la base de datos en Matlab entonces solo se carga
load basededatos  %se carga la base de datos de Matlab
end
num=datos(:,1:end-1)';%datos de entrada
try
nnet.guis.closeAllViews()%cerrada todas las vistas
catch
    disp('algo inesperado sucedi al cerrar las vistas')
end
tar=zeros(4,size(num,2));%target
for k=1:size(num,2)
    tar(datos(k,end),k)=1;%configurar target
end
net = patternnet([80 80 2]);%configuracin inicial
net.performFcn='mse';%error cuadrtico medio
net.TrainParam.showWindow=false;
net.TrainParam.max_fail=4000;%
net.TrainParam.epochs=100;
net.divideparam.trainRatio=0.72;%datos de entrenamiento
net.divideparam.valRatio=0.08;%datos de validacin
net.divideparam.testRatio=0.2; %datos de evaluacin
 net.biasConnect=[true; true; true;  false]; %bias conectadas 
 net.layers{3}.transferFcn='purelin'; %funcin de transferencia
[net,tr] = train(net,num,tar);%entrenamiento y modificacin de arquitectura
[y,tt]=arquitectura(num,net); %agregado de capa de tensin
coeffi=[22.1/1000 0.0477 0.0728 0.425]; %etanol etilenglicol agua mercurio tensin superficial
paraa=0.90;%temp
VH=y.*[coeffi(2)*paraa-coeffi(1) coeffi(3)*paraa-coeffi(2) coeffi(4)*paraa-coeffi(3) 0.34]'+coeffi';
[~,nivel]=max(y);%niveles 
VH=VH(sub2ind(size(VH),nivel,1:size(VH,2)));
tt(:,2)=tt(:,1)./VH';
set(handles.figure1,'UserData',net);
guidata(hObject, handles);
function varargout = riesgo_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
ss=get(handles.uitable1,'Data');
mm=get(handles.figure1,'UserData');
valor=arquitectura(ss',mm);
[~,tipo]=min(valor);
set(handles.text4,'String',['La persona es riesgo tipo ',num2str(tipo)],'Visible','on')
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
function [Y,tt]=arquitectura(num,net)
X=num;%entrada
%parmetros de normalizacin;
x1_step1.xoffset =net.inputs{1}.processSettings{1}.xoffset;
x1_step1.gain = net.inputs{1}.processSettings{1}.gain;
x1_step1.ymin = net.inputs{1}.processSettings{1}.ymin;
b1 = net.b{1};
IW1_1 = net.IW{1};
b2 = net.b{2};
LW2_1 = net.LW{2};
b3 = net.b{3};
LW2_2 = net.LW{7};
LW2_3 = net.LW{12};
isCellX = iscell(X);
if ~isCellX
    X = {X};
end
TS = size(X,2); % timesteps
if ~isempty(X)
    Q = size(X{1},2); % samples/series
else
    Q = 0;
end
Y = cell(1,TS);
%clculo de las capas de salida
for ts=1:TS
    Xp1 = mapminmax_apply(X{1,ts},x1_step1);
     a1 = tansig_apply(repmat(b1,1,Q) + IW1_1*Xp1);
      a2=tansig_apply(repmat(b2,1,Q) + LW2_1*a1);
    a3=purelin_apply(repmat(b3,1,Q)+LW2_2*a2);
    tt=a3'-min(a3')+1;
    a4 = softmax_apply( LW2_3*a3);
      Y{1,ts} = a4;
end
Xf = cell(1,0);
Af = cell(2,0);
if ~isCellX
    Y = cell2mat(Y);
end

function y = mapminmax_apply(x,settings)
y = bsxfun(@minus,x,settings.xoffset);
y = bsxfun(@times,y,settings.gain);
y = bsxfun(@plus,y,settings.ymin);

function a = softmax_apply(n,~)
if isa(n,'gpuArray')
    a = iSoftmaxApplyGPU(n);
else
    a = iSoftmaxApplyCPU(n);
end

function a = iSoftmaxApplyCPU(n)
nmax = max(n,[],1);
n = bsxfun(@minus,n,nmax);
numerator = exp(n);
denominator = sum(numerator,1);
denominator(denominator == 0) = 1;
a = bsxfun(@rdivide,numerator,denominator);

function a = iSoftmaxApplyGPU(n)
nmax = max(n,[],1);
numerator = arrayfun(@iSoftmaxApplyGPUHelper1,n,nmax);
denominator = sum(numerator,1);
a = arrayfun(@iSoftmaxApplyGPUHelper2,numerator,denominator);

function numerator = iSoftmaxApplyGPUHelper1(n,nmax)
numerator = exp(n - nmax);

function a = iSoftmaxApplyGPUHelper2(numerator,denominator)
if (denominator == 0)
    a = numerator;
else
    a = numerator ./ denominator;
end

function a = tansig_apply(n,~)
a = 2 ./ (1 + exp(-2*n)) - 1;

function a=purelin_apply(n,~)
a=n;


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% Se obtiene la informacin de la imagen
imgFRP = imread('5.Efectos de los frp.png');
% Se crea una nueva ventana
ventana = figure('Toolbar','none','Menubar','none','Name','Efectos de los FRP','numbertitle','off');
% Se muestra la imagen de efectos de los FRP
imagen = imshow(imgFRP);
% Se configura el tamao de la ventana
set(ventana,'Units','normalized','Position',[0.2 0.2 0.6 0.6]);
% Se crea un contenedor con scrollers para poder ver la imagen
contenedor = imscrollpanel(ventana,imagen);
% Se elimina la advertencia (la advertencia que aparece no afecta el
% proceso, solo dice que la imagen es muy grande y ser ajustada a la
% pantalla, lo cual no importa)
% warning('off','last')
% Se ajusta la posicin del contenedor de la imagen
set(contenedor,'Units','normalized','Position',[0 0.1 1 0.9])
% Lo siguiente es para agregar la opcin de cambiar el zoom de la imagen
hMagBox = immagbox(ventana,imagen);
pos = get(hMagBox,'Position');
set(hMagBox,'Position',[0 0 pos(3) pos(4)])
% imoverview(imagen) % Visor de la imagen

% Al crear el contenedor la imagen la muestra en la seccin del medio, lo 
% que obliga a la persona que va a leer a desplazarse hasta el comienzo 
% de la imagen para poder leer. Lo siquiente sirve para mostrar 
% automticame la seccin superior de la imagen
api = iptgetapi(contenedor);
loc = api.getVisibleLocation();
api.setVisibleLocation([loc(1) 0]);
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% La siguiente seccin busca concatenar las imgenes de la 1 a la 4. Esto
% podra ahorrarse si se carga a la base de datos la la imagen concatenada
% como tal
ancho = max([size(handles.DB.imgs{1},2)...
             size(handles.DB.imgs{2},2)...
             size(handles.DB.imgs{3},2)...
             size(handles.DB.imgs{4},2)]);

AR = [];

for i=1:4
    if size(handles.DB.imgs{i},2) < ancho
        agregado1 = ceil((ancho - size(handles.DB.imgs{i},2))/2);
        agregado2 = ancho - agregado1 - size(handles.DB.imgs{i},2);
        imagen(1:size(handles.DB.imgs{i},1),1:agregado1,1:3) = 255;
        imagen(:,agregado1+1:agregado1+size(handles.DB.imgs{i},2),1:3) = handles.DB.imgs{i};
        imagen(:,agregado1+size(handles.DB.imgs{i},2)+1:agregado1+size(handles.DB.imgs{i},2)+agregado2,1:3) = 255;
        AR = vertcat(AR,imagen);
        clear imagen
    else
        AR = vertcat(AR,handles.DB.imgs{i});
    end
end

% La imagen obtenida del proceso de concatenado se llama AR

% Se crea una nueva ventana
ventana = figure('Toolbar','none','Menubar','none','Name','Acciones sobre el riesgo','numbertitle','off');
% Se muestra la imagen de acciones de riesgo en la ventana
imagen = imshow(AR);
% Se configura el tamao de la ventana
set(ventana,'Units','normalized','Position',[0.2 0.2 0.6 0.6]);
% Se crea un contenedor con scrollers para poder ver la imagen
contenedor = imscrollpanel(ventana,imagen);
% Se elimina la advertencia (la advertencia que aparece no afecta el
% proceso, solo dice que la imagen es muy grande y ser ajustada a la
% pantalla, lo cual no importa)
% warning('off','last')
% Se ajusta la posicin del contenedor de la imagen
set(contenedor,'Units','normalized','Position',[0 0.1 1 0.9])
% Lo siguiente es para agregar la opcin de cambiar el zoom de la imagen
hMagBox = immagbox(ventana,imagen);
pos = get(hMagBox,'Position');
set(hMagBox,'Position',[0 0 pos(3) pos(4)])
% imoverview(imagen) % Visor de la imagen

% Al crear el contenedor la imagen la muestra en la seccin del medio, lo 
% que obliga a la persona que va a leer a desplazarse hasta el comienzo 
% de la imagen para poder leer. Lo siquiente sirve para mostrar 
% automticame la seccin superior de la imagen
api = iptgetapi(contenedor);
loc = api.getVisibleLocation();
api.setVisibleLocation([loc(1) 0]);
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
