function procesoinicial
%la siguiente linea es la semilla guardada de los resultados
RandStream.setGlobalStream(RandStream('mt19937ar','Seed',387));
%si se quiere obtener nuevos resultados diferentes comentar la linea 3
blancoynegro=false;%si se coloca true las graficas salen en blanco y negro
if ~exist('basededatos.mat','file')%si no existe la base de datos en Matlab entonces se crea
[datos,datosnum]=xlsread('Datos Experimentales NA2.xlsx');%se lee el archivo de Excel
save('basededatos','datos','datosnum');%se guarda la base de datos de Excel en Matlab
else%si ya existe la base de datos en Matlab entonces solo se carga
%h=msgbox('procesando datos...');
h=msgbox({'Physical Surface Tension-Neural Net is Processing'; 'Please wait a moment while all images load...'});
load basededatos  %se carga la base de datos de Matlab
end
num=datos(:,1:end-1)';%datos de entrada
try
nnet.guis.closeAllViews()%cerrada todas las vistas
close all%cerrar figura
clc%limpiar consola
catch
    disp('algo inesperado sucedi al cerrar las vistas')
end
tar=zeros(4,size(num,2));%target
for k=1:size(num,2)
    tar(datos(k,end),k)=1;%configurar target
end
net = patternnet([80 80 2]);%configuracin inicial
net.performFcn='mse';%error cuadratico medio
net.TrainParam.showWindow=false;
net.TrainParam.max_fail=5000;%
net.TrainParam.epochs=4000;
net.divideparam.trainRatio=0.72;%datos de entrenamiento
net.divideparam.valRatio=0.08;%datos de validacion
net.divideparam.testRatio=0.2; %datos de evaluacion
 net.biasConnect=[true; true; true;  false]; %bias conectadas 
 net.layers{3}.transferFcn='purelin'; %funcion de transferencia
[net,tr] = train(net,num,tar);%entrenamiento y modificacion de arquitectura
[y,tt]=arquitectura(num,net);%agregado de capa de tension
coeffi=[22.1/1000 0.0477 0.0728 0.425]; %etanol, etilenglicol, agua, mercurio, tension superficial
paraa=0.90;%temp
VH=y.*[coeffi(2)*paraa-coeffi(1) coeffi(3)*paraa-coeffi(2) coeffi(4)*paraa-coeffi(3) 0.34]'+coeffi';
[~,nivel]=max(y);%niveles 
VH=VH(sub2ind(size(VH),nivel,1:size(VH,2)));
tt(:,2)=tt(:,1)./VH';
figure;
aa=plotperform(tr);
set(aa,'Name','Performance (Desempeo)')
title(' Iterations performance')
ylabel('Mean Square Error')
xlabel([num2str(tr.num_epochs) ' Iterations'])
legend({'Training','Validation','Test','Mejor'})
ss=findobj('DisplayName', 'Entrenamiento');
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','O','MarkerSize',5,'LineWidth',3)
if blancoynegro
    set(ss,'Color',[0 0 0])
end
ss=findobj('DisplayName', 'Validacin');
set(ss,'LineStyle','-','Marker','+','MarkerSize',8,'LineWidth',2)
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
if blancoynegro
    set(ss,'Color',[0 0 0])
end
ss=findobj('DisplayName', 'Test');
if blancoynegro
    set(ss,'Color',[0 0 0])
end
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','.','MarkerSize',3,'LineWidth',3)
ss=findobj('DisplayName', 'Mejor');
delete(ss)
ss=findobj('MarkerSize', 16);
delete(ss)
figure
plotconfusion(tar,net(num))
title('Confusion Matrix')
xlabel('Target Class','FontWeight','bold','FontSize',12)
ylabel('Output Class','FontWeight','bold','FontSize',12);
 xticklabels({'Risk 1','Risk 2','Risk 3','Risk 4',''}')
  yticklabels({'Risk 1','Risk 2','Risk 2','Risk 4',''}')

FFF2=figure;
plotroc(tar,y)
title('Roc Curve','FontWeight','bold','FontSize',16)
xlabel('False Positives','FontWeight','bold','FontSize',12)
ylabel('True Positives','FontWeight','bold','FontSize',12)
set(legend,'String',strrep(get(legend,'String'),'Class','Risk'))
ss=findobj(FFF2,'DisplayName','Risk 1');
if blancoynegro
    set(ss,'Color',[0 0 0])
end
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','O','MarkerSize',3,'LineWidth',3)
ss=findobj(FFF2,'DisplayName','Risk 2');
if blancoynegro
    set(ss,'Color',[0 0 0])
end
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','^','MarkerSize',5,'LineWidth',3)
ss=findobj(FFF2,'DisplayName','Risk 3');
if blancoynegro
    set(ss,'Color',[0 0 0])
end
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','d','MarkerSize',5,'LineWidth',3)
set(ss,'LineStyle','-','Marker','p','MarkerSize',5,'LineWidth',3)
ss=findobj(FFF2,'DisplayName','Risk 4');
if blancoynegro
    set(ss,'Color',[0 0 0])
end
FF=get(ss,'XData');
FF2=get(ss,'YData');
set(ss,'XData',FF(1:100:end),'YData',FF2(1:100:end))
set(ss,'LineStyle','-','Marker','.','MarkerSize',5,'LineWidth',3)

figure
% nivel=datos(:,end);
if blancoynegro==true
plot(tt(nivel==1,1),tt(nivel==1,2),'*k')
hold on
plot(tt(nivel==2,1),tt(nivel==2,2),'ok')
plot(tt(nivel==3,1),tt(nivel==3,2),'dk')
plot(tt(nivel==4,1),tt(nivel==4,2),'+k')
hold off  
else
plot(tt(nivel==1,1),tt(nivel==1,2),'*b')
hold on
plot(tt(nivel==2,1),tt(nivel==2,2),'om')
plot(tt(nivel==3,1),tt(nivel==3,2),'dg')
plot(tt(nivel==4,1),tt(nivel==4,2),'+r')
hold off
end
title('Mass Vs Perimeter')
xlabel('Mass','FontWeight','bold','FontSize',12)
ylabel('Perimeter','FontWeight','bold','FontSize',12);
legend({'Risk 1','Risk 2','Risk 3','Risk 4'})
figure
if blancoynegro==true
kk=nthroot(tt(nivel==1,1)./tt(nivel==1,2),2);
plot(kk,1:length(kk),'ok','MarkerSize',5)
hold on
kk=nthroot(tt(nivel==2,1)./tt(nivel==2,2),2);
plot(kk,1:length(kk),'s','MarkerSize',3,'MarkerEdgeColor','k')
kk=nthroot(tt(nivel==3,1)./tt(nivel==3,2),2);
plot(kk,1:length(kk),'*k')
kk=nthroot(tt(nivel==4,1)./tt(nivel==4,2),2);
plot(kk,1:length(kk),'+k')
hold off       
else
kk=nthroot(tt(nivel==1,1)./tt(nivel==1,2),2);  
plot(kk,1:length(kk),'ob','MarkerSize',5)
hold on
kk=nthroot(tt(nivel==2,1)./tt(nivel==2,2),2); 
plot(kk,1:length(kk),'s','MarkerSize',3,'MarkerEdgeColor','m')
kk=nthroot(tt(nivel==3,1)./tt(nivel==3,2),2); 
plot(kk,1:length(kk),'*g')
kk=nthroot(tt(nivel==4,1)./tt(nivel==4,2),2); 
plot(kk,1:length(kk),'+r')
hold off
end
title('$$${\boldmath${\sqrt{mass/perimeter}}$}','Interpreter','latex','FontSize',16,'FontWeight','bold')
xlabel('$$${\boldmath${\sqrt{mass/perimeter}}$}','Interpreter','latex','FontWeight','bold','FontSize',12)
ylabel('Data','FontWeight','bold','FontSize',12);
legend({'Risk 1','Risk 2','Risk 3','Risk 4'},'Location','northwest','FontWeight','bold')
target=datos(:,end)';
for k=1:4
    TP=sum(nivel(target==k)==k);
    FN=sum(nivel(target==k)~=k);
    FP=sum(nivel(target~=k)==k);
    TN=sum(nivel(nivel~=k)~=k);
sensibilidad(k)=TP/(TP+FN);%true positive rate
especifidad(k)=TN/(TN+FP);%true negative rate
precision(k)=TP/(TP+FP);%positive predictive value
predicionnegativa(k)=TN/(TN+FN);%negative predictive value
errorclasificacion(k)=(FP+FN)/(FP+FN+TP+TN);%classification error
accuracy(k)=(TP+TN)/(TP+TN+FP+FN);%accuracy
prevalencia(k)=(TP+FN)/(TP+TN+FP+FN);%prevalence
end
disp('Sensitivity')
disp(mean(sensibilidad))
disp('Specificity')
disp(mean(especifidad))
disp('Precision')
disp(mean(precision(k)))
disp('Negative predictive value')
disp(mean(predicionnegativa))
disp('Classification Error')
disp(mean(errorclasificacion))
disp('Accuracy')
disp(mean(accuracy))
disp('Prevalence')
disp(mean(prevalencia))
end
function [Y,tt]=arquitectura(num,net)
X=num;%entrada
%parmetros de normalizacin;
x1_step1.xoffset =net.inputs{1}.processSettings{1}.xoffset;
x1_step1.gain = net.inputs{1}.processSettings{1}.gain;
x1_step1.ymin = net.inputs{1}.processSettings{1}.ymin;
b1 = net.b{1};
IW1_1 = net.IW{1};
b2 = net.b{2};
LW2_1 = net.LW{2};
b3 = net.b{3};
LW2_2 = net.LW{7};
LW2_3 = net.LW{12};
isCellX = iscell(X);
if ~isCellX
    X = {X};
end
TS = size(X,2); % timesteps
if ~isempty(X)
    Q = size(X{1},2); % samples/series
else
    Q = 0;
end
Y = cell(1,TS);
%calculo de las capas de salida
for ts=1:TS
    Xp1 = mapminmax_apply(X{1,ts},x1_step1);
     a1 = tansig_apply(repmat(b1,1,Q) + IW1_1*Xp1);
      a2=tansig_apply(repmat(b2,1,Q) + LW2_1*a1);
    a3=purelin_apply(repmat(b3,1,Q)+LW2_2*a2);
    tt=a3'-min(a3')+1;
    a4 = softmax_apply(LW2_3*a3);
      Y{1,ts} = a4;
end
Xf = cell(1,0);
Af = cell(2,0);
if ~isCellX
    Y = cell2mat(Y);
end
end
function y = mapminmax_apply(x,settings)
y = bsxfun(@minus,x,settings.xoffset);
y = bsxfun(@times,y,settings.gain);
y = bsxfun(@plus,y,settings.ymin);
end
function a = softmax_apply(n,~)
if isa(n,'gpuArray')
    a = iSoftmaxApplyGPU(n);
else
    a = iSoftmaxApplyCPU(n);
end
end
function a = iSoftmaxApplyCPU(n)
nmax = max(n,[],1);
n = bsxfun(@minus,n,nmax);
numerator = exp(n);
denominator = sum(numerator,1);
denominator(denominator == 0) = 1;
a = bsxfun(@rdivide,numerator,denominator);
end
function a = iSoftmaxApplyGPU(n)
nmax = max(n,[],1);
numerator = arrayfun(@iSoftmaxApplyGPUHelper1,n,nmax);
denominator = sum(numerator,1);
a = arrayfun(@iSoftmaxApplyGPUHelper2,numerator,denominator);
end
function numerator = iSoftmaxApplyGPUHelper1(n,nmax)
numerator = exp(n - nmax);
end
function a = iSoftmaxApplyGPUHelper2(numerator,denominator)
if (denominator == 0)
    a = numerator;
else
    a = numerator ./ denominator;
end
end
function a = tansig_apply(n,~)
a = 2 ./ (1 + exp(-2*n)) - 1;
end
function a=purelin_apply(n,~)
a=n;
end


